///////////////////////////////////////////////////////////////////////
//Verschlüsselung mit CatMap-Variante
//Vier verschiedene Transformationen hintereinander anwenden
//Danach Permutation der textpunkte
//Periodenbestimmung mit Multi-Threading
////////////////////////////////////////////////////////////
//Vier Matrizen zum Verschlüsseln, vier zum Entschlüsseln
//SecureRandom verwenden, um bessere Zufallszahlen zu erhalten
//////////////////////////////////////////////////////////////
//Verschlüsselten Text als Low-Bit eines RGB- bzw. HSB-Wertes einarbeiten
/////////////////////////////////////////////////////////////////////////
//Umkehrung aller Operationen
////////////////////////////////////////////////////////////////////////

import java.security.SecureRandom;


TransMatrix matrix1,matrix2,matrix3,matrix4,matrix5,matrix6,matrix7,matrix8;
PImage info, text, text1, text2, text3, text4, textV;//Verschiedene text-Stadien bei Ver-und Entschlüsselung
//So viele PImages sind nötig, damit jeder Thread aus seinem eigenen text lesen kann
PImage neuerText1, neuerText2, neuerText3, neuerText4, neuerText5, neuerText6,neuerText7, neuerText8 ;
PImage tmptext, bild, bildV, textE;
int P1,P2,P3,P4;//Perioden
int N ;//Textbreite
int bit1,bit2;
int n = 4000000; //damit Anzahl der Permutationen: 1 000 000
String[] permSchluessel ; 
int s1,t1,l1,s2,t2,l2,s3,t3,l3,s4,t4,l4,l1E,l2E,l3E,l4E;//Schlüssel
Table  schluesselV;//Ablage der Schlüssel
int[] werteV;//ausgelesene Schlüssel
color farbe1,farbe2;

SecureRandom randomGen = new SecureRandom();

void settings(){
   info =  loadImage("info.png");  
   text = loadImage("text.png");  //wegen Mutlithreading viele PImages für text.png
   text1 = loadImage("text.png");  
   text2 = loadImage("text.png");  
   text3 = loadImage("text.png");  
   text4 = loadImage("text.png");  
   neuerText1 = new PImage(N,N); 
   neuerText2 = new PImage(N,N); 
   neuerText3 = new PImage(N,N); 
   neuerText4 = new PImage(N,N); 
   neuerText5 = new PImage(N,N); 
   neuerText6 = new PImage(N,N); 
   neuerText7 = new PImage(N,N); 
   neuerText8 = new PImage(N,N); 
   N = info.width;
    bild = loadImage("data/bild.png");
   P1=P2=P3=P4=0;//Initialisierung der Perioden
   schluesselV = new Table();//gibt csv-Datei für Verschlüsselung
   schluesselV.addColumn("zahl", Table.INT);//für csv-Datei
   size(N,N); 
}

void setup() { 
 image(info,0,0,N,N);
}

void draw () { 
  //braucht man, damit keyPressed() registriert wird
}

void keyPressed(){  
  if (key == 't'){
     image(text,0,0);
  }
  
  if (key == 'v'){ //Verschlüsselung in vier Schritten   
   
   
   println("Versteck-Vorgang gestartet!");
   //Text in Bild verstecken
   textV = loadImage("data/textVerschluesselt.png");
   for (int j = 0; j < N; j++) {
     for (int i = 0; i < N; i++) { 
         farbe1 = textV.get(i,j);//Textfarbe
         bit1 = ((farbe1) & 0xFF) & 1;//Low-Bit von Rot
         farbe2 = bild.get(i,j);//Bildfarbe
         bit2 = ((farbe2 ) & 0xFF) & 1;//Low-Bit von Rot
         if(bit1!=bit2 && bit2==1){
           farbe2 = farbe2-1; 
         }
         if(bit1!=bit2 && bit2==0){
           farbe2 = farbe2+1; 
         }
         bild.set(i,j,farbe2);  
    }
  } 
  image(bild,0,0);
  bild.save("data/bildV.png");
  println("Versteck-Vorgang beendet!");  
    
 }
  
  
  if(key == 'e'){//entschlüsseln in vier Schritten in umgekehrter Reihenfolge
   println("Bild-Information extrahieren");
   
   bildV = loadImage("data/bildV.png");
   textE = loadImage("data/leer.png");
   for (int j = 0; j < N; j++) {
      for (int i = 0; i < N; i++) { 
        farbe1 = bildV.get(i,j);//Textfarbe
        bit1 =farbe1 >> 32 & 1;
        if(bit1 == 0){
          textE.set(i,j,color(0));
        }else{
          textE.set(i,j,color(255));
        }      
      }
    } 
    image(textE,0,0);
    textE.save("data/textE.png");
   
   println("Entschlüsselung startet!");
   //Permutation rückgängig machen
   int ax, ay, bx, by;
   permSchluessel = loadStrings("permSchluessel.txt");
   tmptext = loadImage("textVerschluesselt.png");   
   color tauschA = color(0,0,0);
   color tauschB = color(0,0,0);
  
   for(int i = 0; i<n; i= i+4){
      ax = Integer.parseInt(permSchluessel[n-2-i]);
      ay = Integer.parseInt(permSchluessel[n-1-i]);
      bx = Integer.parseInt(permSchluessel[n-4-i]);
      by = Integer.parseInt(permSchluessel[n-3-i]);
      tauschA = tmptext.get(ax,ay);
      tauschB = tmptext.get(bx,by);
      tmptext.set(ax,ay,tauschB) ;
      tmptext.set(bx,by,tauschA) ;
    }
    tmptext.save("data/textTeilEntschluesselt.png");
    
    schluesselV = loadTable("schluesselV.csv", "header");//Schlüssel auslesen
    textV = loadImage("textTeilEntschluesselt.png");   
    werteV = new int[schluesselV.getRowCount()];
    int i =0;
    for (TableRow row : schluesselV.rows()) {  
        int id = row.getInt("zahl");
        werteV[i] = id;
        i++;
    }
   //AT entschlüsseln in vier Schritten in umgekehrter Reihenfolge
    s1 = werteV[12];  t1 = werteV[13];  l1 =werteV[15]- werteV[14];  //P-l 
    matrix5 = new TransMatrix(s1,t1,textV,l1,N);
    neuerText5 = matrix5.catMappen(); 
    image(neuerText5,0,0); save("data/textE1.png");
   
    s2 = werteV[8];  t2 = werteV[9];  l2 = werteV[11]- werteV[10];   
    matrix6 = new TransMatrix(s2,t2,neuerText5,l2,N);
    neuerText6 = matrix6.catMappen(); 
    image(neuerText6,0,0); save("data/textE2.png");
    
    s3 = werteV[4];  t3 = werteV[5];  l3 = werteV[7]- werteV[6];   
    matrix7 = new TransMatrix(s3,t3,neuerText6,l3,N);
    neuerText7 = matrix7.catMappen(); 
    image(neuerText7,0,0); save("data/textE3.png");
    
    s4 = werteV[0];  t4 = werteV[1];  l4 = werteV[3]- werteV[2];  
    matrix8 = new TransMatrix(s4,t4,neuerText7,l4,N);
    neuerText8 = matrix8.catMappen();
    image(neuerText8,0,0); save("data/textEntschluesselt.png");
    
     println("Entschlüsselung beendet!");
  }
  
  if(key == 'k'){//pseudo-zufällige Schlüssel erzeugen
      println("Die Berechnung der Schlüssel kann einige Sekunden dauern!");
      s1 =randomGen.nextInt(N);t1 =randomGen.nextInt(N);l1 = 2;//l-Werte nur vorläufig
      s2 =randomGen.nextInt(N);t2 =randomGen.nextInt(N);l2 = 2;
      s3 =randomGen.nextInt(N);t3 =randomGen.nextInt(N);l3 = 2;
      s4 =randomGen.nextInt(N);t4 =randomGen.nextInt(N);l4 = 2;
      schluesselV.setInt(0,  "zahl", s1);
      schluesselV.setInt(1,  "zahl", t1);
      schluesselV.setInt(2,  "zahl", l1);
      schluesselV.setInt(3,  "zahl", P1);
      schluesselV.setInt(4,  "zahl", s2);
      schluesselV.setInt(5,  "zahl", t2);
      schluesselV.setInt(6,  "zahl", l2);
      schluesselV.setInt(7,  "zahl", P2);
      schluesselV.setInt(8,  "zahl", s3);
      schluesselV.setInt(9,  "zahl", t3);
      schluesselV.setInt(10, "zahl", l3);
      schluesselV.setInt(11, "zahl", P3);
      schluesselV.setInt(12, "zahl", s4);
      schluesselV.setInt(13, "zahl", t4);
      schluesselV.setInt(14, "zahl", l4);
      schluesselV.setInt(15, "zahl", P4); 
      werteV = new int[schluesselV.getRowCount()];
      int i =0;
      for (TableRow row : schluesselV.rows()) {  
          int id = row.getInt("zahl");
          werteV[i] = id;
          i++;
      }
       
      s1 = werteV[0];  t1 = werteV[1];  l1 = werteV[2];  
      matrix1 = new TransMatrix(s1,t1,text1,l1,N); 
      s2 = werteV[4];  t2 = werteV[5];  l2 = werteV[6];  
      matrix2 = new TransMatrix(s2,t2,neuerText1,l2,N);   
      s3 = werteV[8];  t3 = werteV[9];  l3 = werteV[10];   
      matrix3 = new TransMatrix(s3,t3,neuerText2,l3,N);   
      s4 = werteV[12];  t4 = werteV[13];  l4 = werteV[14];  
      matrix4= new TransMatrix(s4,t4,neuerText3,l4,N);
   
    
     ArrayList<WorkThread> workers = new ArrayList<WorkThread>();//Multithreading
      //Perioden müssen bestimmt werden, damit die Anzahl der jeweiligen Transformationen bestimmt werden kann.
      workers.add(new WorkThread(0,matrix1,text1)); //Wurde als Anzahl der Transformation z. B. 323 angegeben,
      workers.add(new WorkThread(1,matrix2,text2)); //und die zugehörige Periode ist 200, dann muss die Transformation
      workers.add(new WorkThread(2,matrix3,text3)); //bei der Verschlüsselung nur 123 mal, und
      workers.add(new WorkThread(3,matrix4,text4)); //bei der Entschlüsselung 200-123 = 77 mal angewand werden.
          
       for (WorkThread worker : workers) {   
        while (worker.running)
        {
          try{
          Thread.sleep(10);  
          }catch (Exception e) {  }  ;                
        }
      }    
          
      P1= workers.get(0).P1; l1= 3+randomGen.nextInt(P1-3); l1E=P1-l1;//Anzahl der jeweiligen Transformationen festlegen
      P2= workers.get(1).P2; l2= 3+randomGen.nextInt(P2-3); l2E=P2-l2;
      P3= workers.get(2).P3; l3= 3+randomGen.nextInt(P3-3); l3E=P3-l3;
      P4= workers.get(3).P4; l4= 3+randomGen.nextInt(P4-3); l4E=P4-l4;
      println("Die Perioden sind: "+P1,P2,P3,P4);//Nur zur Information 
      println("Die Schlüssel sind: ");
      println(s1,t1,l1+"    "+s2,t2,l2+"    "+s3,t3,l3+"    "+s4,t4,l4);//Nur zur Information
      println(s4,t4,l4E+"    "+s3,t3,l3E+"    "+s2,t2,l2E+"    "+s1,t1,l1E);//Nur zur Information
      println("In Ordner data als <schluesselV.csv> und <schluesselE.csv> abgelegt");
         
      schluesselV.setInt(2, "zahl",  l1);    //korrigierte Werte
      schluesselV.setInt(3, "zahl",  P1); 
      schluesselV.setInt(6, "zahl",  l2);    
      schluesselV.setInt(7, "zahl",  P2); 
      schluesselV.setInt(10, "zahl", l3);   
      schluesselV.setInt(11, "zahl", P3); 
      schluesselV.setInt(14, "zahl", l4);
      schluesselV.setInt(15, "zahl", P4); 
      
      saveTable(schluesselV, "data/schluesselV.csv");  
     
     
       permSchluessel = new String[n];//Permutationsschlüssel
       for (int iP = 0; iP < n; iP ++ ) {
          permSchluessel[iP] = str(randomGen.nextInt(N));    
       }
       saveStrings("data/permSchluessel.txt", permSchluessel);
       println("Schlüssel berechnet.");
       println("Drücken Sie nun die Taste <v> zum Verschlüsseln des Textes!");
  }
}